#include <SPI.h>
#include <nRF24L01_2.h>
#include <RF24_2.h>

RF24 radio(9, 10);




byte rxAddr[6] = "Node1";

long int tms;
int SER_Pin = 6;   //pin 14 on the 75HC595
int RCLK_Pin = 5;  //pin 12 on the 75HC595
int SRCLK_Pin = 4; //pin 11 on the 75HC595
int EnablePin=3;
int SafteyPin =2;

//How many of the shift registers - change this
#define number_of_74hc595s 2 

//do not touch
#define numOfRegisterPins number_of_74hc595s * 8

boolean registers[numOfRegisterPins];

void setup(){
  
  
  Serial.begin(115200);
  
  
  pinMode(SER_Pin, OUTPUT);
  pinMode(RCLK_Pin, OUTPUT);
  pinMode(SRCLK_Pin, OUTPUT);
  pinMode(EnablePin,OUTPUT);
  pinMode(SafteyPin,INPUT_PULLUP);
  
  //reset all register pins
  clearRegisters();
  writeRegisters();
  //digitalWrite(EnablePin,HIGH); //add to enable output at startup
  radio.begin();
   //radio.setRetries(15, 15);
  radio.setDataRate(RF24_250KBPS);
  //radio.setPALevel(RF24_PA_MAX);
  radio.openReadingPipe(0, rxAddr);
  radio.startListening();
  
}               


//set all register pins to LOW
void clearRegisters(){
  /*for(int i = numOfRegisterPins - 1; i >=  0; i--){
    // registers[i] = LOW; */ //include for normal use

   for(int i = numOfRegisterPins - 1; i >= 0;i--) {//Included because of  
     registers[i] = HIGH; // active low relays
   }
} 


//Set and display registers
//Only call AFTER all values are set how you would like (slow otherwise)
void writeRegisters(){

  digitalWrite(RCLK_Pin, LOW);

  for(int i = numOfRegisterPins - 1; i >=  0; i--){
    digitalWrite(SRCLK_Pin, LOW);

    int val = registers[i];

    digitalWrite(SER_Pin, val);
    digitalWrite(SRCLK_Pin, HIGH);

  }
  digitalWrite(RCLK_Pin, HIGH);

}

//set an individual pin HIGH or LOW
void setRegisterPin(int index, int value){
  registers[index] = value;
}


void loop(){
  
  if (digitalRead(SafteyPin)== 0){
   Serial.println("Waiting");
   digitalWrite(EnablePin,LOW);
   }  
   else if (digitalRead(SafteyPin)==1){
     digitalWrite(EnablePin,HIGH);
   }   
 
char text[14] = {0};
   
  if (radio.available())
  {
    radio.read(&text, sizeof(text));
  // Serial.println(text);
  tms = millis();
  Serial.println(text);
  }
   Serial.println(millis()-tms);
 
  if (!radio.available())
  {
    if ((millis()- tms) >= 150) 
    {
    clearRegisters();
    digitalWrite(EnablePin,LOW);
    }
  }
  
  

 
  writePins(text);

  
  writeRegisters();  //MUST BE CALLED TO DISPLAY CHANGES
}

void writePins(char* text){
     
   
   for (int i=0; i < 18; i++){
     if ((text[i]-48) == 0){
        setRegisterPin(i,LOW);
     }
     else if ((text[i]-48) == 1) {
       setRegisterPin(i,HIGH);
     }
  
   }
}
